use Gimp;
use Bfe;
use Bfe::Graphics;
use strict;

package Bfe::Span;

sub generate {
  
  my $parm_list = shift;
  
  my $pwd = `pwd`;
  chop $pwd;
  
   foreach my $parms (@$parm_list) {

    my $bfe = new Bfe($parms->{fract});

    if(defined $parms->{preview} && defined $parms->{preview}{html}) {
      open HTML_FILE, ">$parms->{preview}{html}";
      print HTML_FILE "<table>";
    }

    my $ymin = $bfe->{center}[1] - $bfe->{span}[1]/2;
    my $ymax = $bfe->{center}[1] + $bfe->{span}[1]/2;
    my $xmin = $bfe->{center}[0] - $bfe->{span}[0]/2;
    my $xmax = $bfe->{center}[0] + $bfe->{span}[0]/2;
    my $ydelta;
    my $ysliver;
    my $xsliver;
    
    if(defined $parms->{overlap}) {
      $ydelta = ($ymax-$ymin)/($parms->{pages_vert}*(1-$parms->{overlap})+
			       $parms->{overlap});
    } else {
      $ydelta = ($ymax - $ymin)/$parms->{pages_vert};
    }

    my $xdelta = $bfe->{page_size}[0]/$bfe->{page_size}[1]*$ydelta;

    if (defined $parms->{overlap}) { # sliver is how much to decrement center
      $ysliver = $ydelta*$parms->{overlap};
      $xsliver = $bfe->{page_size}[0]/$bfe->{page_size}[1]*$ysliver;
    }
    
    my $hmax;
    my $value;

    if(defined $parms->{overlap}) {
      $value = ($bfe->{span}[0]+$xsliver)/($xdelta+$xsliver);
    } else {
      $value = $bfe->{span}[0]/$xdelta
    }

    $hmax = int($value);
    $hmax -- if ($value - $hmax == 0);
    
    print "xsliver is $xsliver\n";
    print "hmax is $hmax\n";
    print "value is $value\n";

    for my $vi (0..($parms->{pages_vert}-1)) {
      my $this_ymin = $ymin+$vi*$ydelta;
      print HTML_FILE "<tr>" if (defined $parms->{preview}{html});
      for my $hi (0 .. $hmax) {
				# determine range of current frame
	my $ysize = $bfe->{dpi}*$bfe->{page_size}[1];
	my $xsize = $bfe->{dpi}*$bfe->{page_size}[0];

	my $xspan = $xdelta;
	my $yspan = $ydelta;

	my $xcenter = $xmin + $hi * $xdelta + $xdelta/2;
	my $ycenter = $ymin + $vi * $ydelta + $ydelta/2;

	if($hi == $hmax) {
	  my $xsmaller;
	  if (defined $parms->{overlap}) {
	    $xsmaller = ($xmax-$xmin-$hi*($xdelta-$xsliver))/$xdelta;
	  } else {
	    $xsmaller = ($xmax-$xmin-$hi*$xdelta)/$xdelta;
	  }

	  $xsize *= $xsmaller;
	  $xcenter -= ($xspan - $xspan*$xsmaller)/2;
	  $xspan *= $xsmaller;
	}

	$bfe->{area} = ($xspan * $yspan)/(($xmax - $xmin)*($ymax - $ymin));
	
	$ycenter -= $ysliver*$vi if ($vi != 0 && defined $parms->{overlap});
	$xcenter -= $xsliver*$hi if ($hi != 0 && defined $parms->{overlap});

	$bfe->{size} = [$xsize, $ysize]; # set fields in bfe
	$bfe->{span} = [$xspan, $yspan];
	@{$bfe->{center}}[0,1] = ($xcenter, $ycenter);
	$bfe->{outfile} = $bfe->{prefix}."$hi.$vi.png";
	$bfe->generate unless (defined $parms->{preview_only} ||
			       (-f $bfe->{outfile} && $bfe->{no_overwrite}));

	if($parms->{do_preview}) {
	  my $scale = $parms->{preview}{dpi}/$bfe->{dpi};
	  for (@{$bfe->{size}}) { $_ *= $scale; }
	  $bfe->{outfile} = $parms->{preview}{prefix}.".".$bfe->{outfile};
	  $bfe->generate;
	  print HTML_FILE "<td><img src = \"$bfe->{outfile}\"></td>"
	    if (defined $parms->{preview}{html});	 
	}

	Bfe::Graphics::make_printer_food("$pwd/$hi.$vi.png","$pwd/$hi.$vi.out")
	  if($parms->{printer_food} && ! -f "$hi.$vi.out");
      }
      print HTML_FILE "</tr>" if (defined $parms->{preview}{html});
    }
    if(defined $parms->{preview}{html}) {
      print HTML_FILE "</table>";
      close HTML_FILE;
    }
  }
}
1;
