
package Bfe::Zoom;
use Bfe;
use Bfe::Graphics;
use strict;


sub generate {

  my $parm_list = shift;

  my $pwd = `pwd`;
  chop $pwd;

  foreach my $parms (@$parm_list) {
    
    my $output_html = 0;
  
    open(HTML_FILE, '>'.$parms->{'html'}) && ($output_html = 1)
      if($parms->{html});
    print HTML_FILE $parms->{head} if ($output_html && $parms->{head});
    
    my $zoom;
    
    my $img_idx = 0;
    
    for $zoom (@{$parms->{zoom}}) {
      
      $img_idx += $#{$zoom->{seq}} if ($zoom->{reverse});
      
      print HTML_FILE $zoom->{head} if($output_html && $zoom->{head});
      #    print HTML_FILE "<TABLE><TR>" if($output_html);
      
#      print "zoom is $zoom\n";
#      for (keys %$zoom) { print "$_ => $zoom->{$_}\n"; }

#      for (keys %{$zoom->{init}}) { print "$_ => $zoom->{init}->{$_}\n"; }

      my $bfe = new Bfe($zoom->{init});

      $bfe->{size}[1] = int($bfe->{size}[0]*$bfe->{span}[1]/$bfe->{span}[0]);
      
      @{$zoom->{seq}[0]}[0..1] = @{$bfe->{center}}[0..1];
      @{$zoom->{seq}[0]}[2..3] = @{$bfe->{span}};
      $zoom->{seq}[0][4] = $bfe->{maxiter};
      
      for my $zoomi (1 .. $#{$zoom->{seq}}) {
	my $prev = $zoom->{seq}[$zoomi-1];
	my $curr = $zoom->{seq}[$zoomi];
	for (0, 1)    { $curr->[$_] = $prev->[$_] unless ($curr->[$_]); }
	for (2, 3, 4) { $curr->[$_] *= $prev->[$_]; }
      }
      
      for my $zoomi (0 .. $#{$zoom->{seq}}) {  
	
	my ($x_center, $y_center, $x_span, $y_span, $maxiter) =
	  @{$zoom->{seq}[$zoomi]};
	
	$bfe->{size}[0] = int($bfe->{size}[1]*$x_span/$y_span);
	
	$bfe->{outfile} = "$img_idx.png";
	$bfe->{span} = [$x_span, $y_span];
	$bfe->{maxiter} = $maxiter;
	@{$bfe->{center}}[0,1] = ($x_center, $y_center);

	$bfe->generate unless (-f "$img_idx.png");	
	
	my $box_xmin;
	my $box_xspan;
	my $box_ymin;
	my $box_yspan;
	
	if($zoom->{seq}[$zoomi+1]) {
	  my ($x_center_n, $y_center_n, $x_span_n, $y_span_n) = 
	    @{$zoom->{seq}[$zoomi+1]};
	  
	  $box_xmin = int(($x_center_n-$x_span_n/2 - ($x_center-$x_span/2))/
			  $x_span*$bfe->{size}[0]);
	  $box_xspan = int($x_span_n/$x_span*$bfe->{size}[0]);
	  
	  $box_ymin = int(($y_center_n-$y_span_n/2 - ($y_center-$y_span/2))/
			  $y_span*$bfe->{size}[1]);
	  $box_yspan = int($y_span_n/$y_span*$bfe->{size}[1]);
	} else {
	  $box_xmin = $bfe->{size}[0]/2;
	  $box_ymin = $bfe->{size}[1]/2;
	}
	
	Bfe::Graphics::boxify_and_jpeg("$pwd/$img_idx.png", $box_xmin, 
				       $box_ymin, $box_xspan, $box_yspan, 
				       1, defined $zoom->{seq}[$zoomi+1]) 
	  unless(-f "$pwd/$img_idx.jpeg");
	
	if($zoom->{reverse}) {
	  $img_idx--;
	} else {
	  inline_img("$img_idx.jpeg", @{$bfe->{size}}, *HTML_FILE{IO}) 
	    if ($output_html);
	  $img_idx++;
	}
      }
      if($zoom->{reverse}) {
	for my $zoomi (1 .. @{$zoom->{seq}}) {
	  my ($xspan, $yspan);
	  (undef, undef, $xspan, $yspan) = @{$zoom->{seq}[$zoomi-1]};
	  inline_img(($img_idx+$zoomi).".jpeg", int($bfe->{size}[1]*$xspan/$yspan),
		     $bfe->{size}[1], *HTML_FILE{IO}) 
	    if ($output_html);
	}
	$img_idx += @{$zoom->{seq}} ;
      }    
      #    print HTML_FILE "</tr></table>" if ($output_html);
      print HTML_FILE $zoom->{tail} if ($output_html && $zoom->{tail});
    }
    print HTML_FILE $parms->{tail} if ($output_html && $parms->{tail});
  }
}
  
sub inline_img {
  my ($name, $width, $height, $fh) = @_;
  print $fh "<img border = 2 height = $height width = $width src = \"$name\">";
}

1;
