/* brainsik fractal generator */
/* hacked beyond recoginition by brian */
/*
 * TODO:
 *
 * better error handling of incorrect palletes
 *
 *
 *
 */
#define THREADS
#include <assert.h>
#ifdef THREADS
#include <pthread.h>
#include <semaphore.h>
#endif
#include <png.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libquat.h>
#ifdef THREADS
#include "prioq.h"
#endif
#include "splat.h"
#include <time.h>

#define HALFPI 1.5707963268

extern "C" {
  int eq_table_iter(eq_table*, double *);
}

#define COLOR
#define PALLETE_SIZE 4

#define PIXEL unsigned char

#define WYDE_R(a) (*((WYDE*)(a)))
#define WYDE_G(a) (*(((WYDE*)(a))+1))
#define WYDE_B(a) (*(((WYDE*)(a))+2))

#define BYTE_R(a) (*((BYTE*)(a)))
#define BYTE_G(a) (*(((BYTE*)(a))+1))
#define BYTE_B(a) (*(((BYTE*)(a))+2))

#define WYDE unsigned short
#define BYTE unsigned char

extern struct yy_buffer_state * yy_scan_string(const char *);
extern int yyparse();
extern int yydebug;

typedef struct {
    int height;			// image height in pixels
    int width;			// image width in pixels
    double bailout;		// escape radius
    int maxiter;		// maxium iterations
    int maxpow;			// largest power in polynomial (for coloring)
    char filename[64];		// name of output file
    quat crosshair;		// center of image
    double hspan, vspan;	// distance covered in quaternion space
    quat min;			// minimum corner coords
    quat vstep, hstep;		// how much to step in each direction
    int limit;			// how often to cycle pallete
    int currblock;		// which block needs to be done next?
    int num_threads;
    png_structp png_ptr;	// png stuff
    png_infop info_ptr;
    FILE * png_file;
#ifdef THREADS
    sem_t diverg_mutex;
    Queue<PIXEL> * q;		// priority queue to hold completed lines
#endif
    eq_table ** table;		// for function iteration
    int currthread;		// for assiging thread numbers
    BYTE * pallete;		// array of pallete nodes
    int pallete_size;		// number of nodes in pallete
    char * pallete_file;
    int image_bytes;		// number of bytes per channel
    int image_bits;		// image_bytes * 8
    int image_channels;		// either 1 or 3
    bool smooth;
    bool color_by_angle;
    libquat_iter_func f;	// iteration function
    libquat_iter_func_1 f1;	// iteration function
    bool compile;
    double seedx, seedy;	/* seeds for attractor (z_0) */
    double div;			/* for ugly hack involving attractor coloring*/
} Parameters;

void make_attractor(Parameters *);
void load_pallete(Parameters *);
void compute_line(Parameters *, PIXEL *, int, int);
void init_png(Parameters * parms);
void * start_threads(void * _parms);
void * test_divergence(void * _parms);
void				/* from gtk_colorselection */
hsv_to_rgb (double  h, double  s, double  v,
	    double *r, double *g, double *b);

int main(int argc, char *argv[])
{
  Parameters * parms = new Parameters;
  int i, fractype = 0;
  int btest = 0;

  yydebug = 0;
  
  parms->num_threads = 1;
  parms->height = parms->width = parms->bailout = 0; /* defaults */
  strcpy(parms->filename, "output.gif");
  parms->crosshair.s = parms->crosshair.a = 0;
  parms->hspan = parms->vspan = 3.0;
  parms->maxiter = 500;
  parms->limit = 256;
  parms->maxpow = 2;
  parms->image_bytes = 1;
  parms->image_channels = 1;
  parms->smooth = 0;
  parms->color_by_angle = 0;
  parms->compile = false;

  char * func = NULL;
  char * init_func = NULL;
  bool attractor_mode = false;

  for (i = 1; i < argc; ++i)
      if(strcmp(argv[i], "-ib") == 0)
	  parms->image_bytes = atoi(argv[++i]);
  
      else if(strcmp(argv[i], "-a") == 0)
	  attractor_mode = 1;

      else if(strcmp(argv[i], "-sd") == 0) {
	  parms->seedx = atoi(argv[++i]);
	  parms->seedy = atoi(argv[++i]);
      }
	
      else if(strcmp(argv[i], "-s") == 0)
	  parms->smooth = 1;

      else if(strcmp(argv[i], "-cba") == 0)
	  parms->color_by_angle = 1;
  
      else if(strcmp(argv[i], "-ic") == 0)
	  parms->image_channels = atoi(argv[++i]);
      
      else if(strcmp(argv[i], "-nt") == 0)
	  parms->num_threads = atoi(argv[++i]);

      else if (strcmp(argv[i], "-n") == 0) 
	  parms->div = atof(argv[++i]);
  
      else if (strcmp(argv[i], "-pf") == 0) 
	  parms->pallete_file = argv[++i];

      else if(strcmp(argv[i], "-c") == 0)
	  parms->compile = true;
  
      else if (strcmp(argv[i], "-size") == 0) {
	  parms->width = atoi(argv[++i]);
	  parms->height = atoi(argv[++i]);
      }

      else if (strcmp(argv[i], "-b") == 0) {
	  sscanf(argv[++i], " %lf ", &parms->bailout);
	  printf("%s\n", argv[i]);
      }
      else if (strcmp(argv[i], "-center") == 0) {
	  parms->crosshair.s = atof(argv[++i]);
	  parms->crosshair.a = atof(argv[++i]);
	  parms->crosshair.b = atof(argv[++i]);
	  parms->crosshair.c = atof(argv[++i]);
      }

      else if (strcmp(argv[i], "-span") == 0) {
	  parms->hspan = atof(argv[++i]);
	  parms->vspan = atof(argv[++i]);
      }

      else if (strcmp(argv[i], "-hv") == 0) {
	  parms->hstep.s = atof(argv[++i]);
	  parms->hstep.a = atof(argv[++i]);
	  parms->hstep.b = atof(argv[++i]);
	  parms->hstep.c = atof(argv[++i]);
      }

      else if(strcmp(argv[i], "-vv") == 0) {
	  parms->vstep.s = atof(argv[++i]);
	  parms->vstep.a = atof(argv[++i]);
	  parms->vstep.b = atof(argv[++i]);
	  parms->vstep.c = atof(argv[++i]); 
      }

      else if (strcmp(argv[i], "-f") == 0)
	  strcpy(parms->filename, argv[++i]);

      else if(strcmp(argv[i], "-i") == 0)
	  parms->maxiter = atoi(argv[++i]);

      else if(strcmp(argv[i], "-gt") == 0)
	  btest = 1;

      else if(strcmp(argv[i], "-l") == 0)
	  parms->limit = atof(argv[++i]);

      else if(strcmp(argv[i], "-F") == 0)
	  func = argv[++i];

      else if(strcmp(argv[i], "-IF") == 0)
	  init_func = argv[++i];

      else if(strcmp(argv[i], "-p") == 0)
	  parms->maxpow = atof(argv[++i]);
  
  if (!parms->height || !parms->width) {
      parms->height = parms->width = 200;
      printf("Image size defaulting to %dx%d.\n", parms->width, parms->height);
  } if (!parms->bailout) {
      parms->bailout = 100;
      printf("Bailout value defaulting to %d.\n", parms->bailout);
  } if (!func) {
      printf("need func...\n");
  }

  parms->image_bits = parms->image_bytes*8;
//  parms->image_channels = 1;

  load_pallete(parms);

/*   printf("vstep is %.2f %.2f %.2f %.2f\n", parms->vstep.s,  */
/* 	 parms->vstep.a, parms->vstep.b, parms->vstep.c); */
/*   printf("hstep is %.2f %.2f %.2f %.2f\n", parms->hstep.s,  */
/* 	 parms->hstep.a, parms->hstep.b, parms->hstep.c); */


  double sum = sqrt(parms->vstep.s*parms->vstep.s+
		    parms->vstep.a*parms->vstep.a+
		    parms->vstep.b*parms->vstep.b+
		    parms->vstep.c*parms->vstep.c);

  parms->vstep.s /= sum;
  parms->vstep.a /= sum;
  parms->vstep.b /= sum;
  parms->vstep.c /= sum;

  parms->vstep.s *= parms->vspan/parms->height;
  parms->vstep.a *= parms->vspan/parms->height;
  parms->vstep.b *= parms->vspan/parms->height;
  parms->vstep.c *= parms->vspan/parms->height;

/*   printf("vstep is %.10f %.10f %.10f %.10f\n", parms->vstep.s,  */
/* 	 parms->vstep.a, parms->vstep.b, parms->vstep.c); */

  sum = sqrt(parms->hstep.s*parms->hstep.s+
	     parms->hstep.a*parms->hstep.a+
	     parms->hstep.b*parms->hstep.b+
	     parms->hstep.c*parms->hstep.c);

  parms->hstep.s /= sum;
  parms->hstep.a /= sum;
  parms->hstep.b /= sum;
  parms->hstep.c /= sum;

  parms->hstep.s *= parms->hspan/parms->width;
  parms->hstep.a *= parms->hspan/parms->width;
  parms->hstep.b *= parms->hspan/parms->width;
  parms->hstep.c *= parms->hspan/parms->width;

/*   printf("hstep is %.10f %.10f %.10f %.10f\n", parms->hstep.s,  */
/* 	 parms->hstep.a, parms->hstep.b, parms->hstep.c); */

  parms->min.s = parms->crosshair.s-(parms->height/2*parms->vstep.s+
				     parms->width/2*parms->hstep.s);
  parms->min.a = parms->crosshair.a-(parms->height/2*parms->vstep.a+
				     parms->width/2*parms->hstep.a);
  parms->min.b = parms->crosshair.b-(parms->height/2*parms->vstep.b+
				     parms->width/2*parms->hstep.b);
  parms->min.c = parms->crosshair.c-(parms->height/2*parms->vstep.c+
				     parms->width/2*parms->hstep.c);

/*   printf("min is %.2f %.2f %.2f %.2f\n", parms->min.s,  */
/* 	 parms->min.a, parms->min.b, parms->min.c); */
/*   printf("vstep is %.2f %.2f %.2f %.2f\n", parms->vstep.s,  */
/* 	 parms->vstep.a, parms->vstep.b, parms->vstep.c); */
/*   printf("hstep is %.2f %.2f %.2f %.2f\n", parms->hstep.s,  */
/* 	 parms->hstep.a, parms->hstep.b, parms->hstep.c); */

  printf("func is %s\n", func);
  parms->table = new eq_table *[parms->num_threads];
  for(int i = 0 ; i < parms->num_threads ; i++) {
      parms->table[i] = new eq_table(func, init_func,
				     parms->maxiter,
				     parms->bailout);
      if(btest)
	  parms->table[i]->set_btest(LIBQUAT_GT);
  }
//  parms->table[0]->set_debug();
  if(parms->compile)
      parms->f = parms->table[0]->compile();
  else
      parms->f = &eq_table_iter;

  parms->f1 = parms->table[0]->compile_1();

  init_png(parms);		/* initialze png structs */

  
  if(attractor_mode) {
      printf("attractor_mode\n");
      make_attractor(parms);
      png_write_end(parms->png_ptr, NULL);
      fclose(parms->png_file);
      exit(0);
  }

  parms->currthread = 0;
  
#ifdef THREADS
  parms->q = new Queue<PIXEL>(100);

  sem_init(&parms->diverg_mutex, 0, 1);

  pthread_t writer;
  pthread_attr_t attrs;		/* create threads */
  pthread_attr_init(&attrs);
  pthread_attr_setdetachstate(&attrs, PTHREAD_CREATE_DETACHED);
  
  pthread_create(&writer, &attrs, start_threads, (void *)parms);
#endif
//   printf("check2\n"); 

  PIXEL * line;

  int count = 0;
  char buf[20];
  
  printf("Progress -       ");

  while(1) {
#ifdef THREADS      
      line = parms->q->remove();
#endif
      if(!line) 
	  break;
      count++;
      if(count % 10 == 0) {
	  sprintf(buf, "%2.1f %%", ((float)count)/parms->height*100);
	  if(strlen(buf)==5)
	      printf("\b\b\b\b\b\b %s", buf);
	  else
	      printf("\b\b\b\b\b\b%s", buf);
	  fflush(stdout);
      }
      png_write_rows(parms->png_ptr, (unsigned char **)&line, 1);
/*     printf("wrote row\n"); */
      delete line;
  }

/*   printf("check3\n"); */

  png_write_end(parms->png_ptr, NULL);
  fclose(parms->png_file);

  printf("\nCrosshair: (%f,%f)   Resolution: %f x %f\n", 
	 parms->crosshair.s, parms->crosshair.a, parms->hspan, parms->vspan);
  printf("Output file to %s.\n", parms->filename);
  return 0;
}

void make_attractor(Parameters *parms) {

    double c1 = parms->hspan/2-parms->crosshair.s;
    double c2 = parms->vspan/2-parms->crosshair.a;
    double c3 = parms->width/parms->hspan;
    double c4 = parms->height/parms->vspan;
    double c5 = 1/c3;
    double c6 = 1/c4;
    double img_x, img_y;

    double * v = new double[4];
    float ** attractor;
    v[0] = parms->seedx;
    v[1] = parms->seedy;
    v[2] = v[3] = 0;
 
    attractor = new float*[parms->height];

    for(int i = 0 ; i < parms->height ; i++) {
	attractor[i] = new float[parms->width*parms->image_bytes*
				parms->image_channels];
	for(int j = 0 ; 
	    j < parms->width*parms->image_bytes*parms->image_channels ; 
	    j++) 
	    attractor[i][j] = 0;
    }

    Splat * s = new Splat(0.4, 0.0005, 800);
   
    int splat_size = 5;
    int mid_mod = (splat_size-1)/2;
    int iterations = parms->maxiter;
    char buf[20];
    clock_t clock1 = clock();
    (*parms->f1)(v, 1);
    while(parms->maxiter--) {
	(*parms->f1)(v, 0);
	img_x = (v[0]+c1)*c3;
	img_y = (v[1]+c2)*c4;

	int start_x = (int)rint(img_x)-mid_mod;
	int start_y = (int)rint(img_y)-mid_mod;
	int max_x = start_x + splat_size;
	int max_y = start_y + splat_size;
	
	for(int j = start_y ; j < max_y ; j++)
	    if(j >= 0 && j < parms->height)
		for(int i = start_x ; i < max_x ; i++)
		    if(i >= 0 && i < parms->width)
			attractor[j][i] += s->area_under(img_x-i, img_y-j);

	if(!(parms->maxiter & 0xFFF)) {
	    sprintf(buf, "%2.1f %%", 100-100*((float)parms->maxiter)/iterations);
	    if(strlen(buf)==5)
		printf("\b\b\b\b\b\b %s", buf);
	    else
		printf("\b\b\b\b\b\b%s", buf);
	    fflush(stdout);
	}
    }
    clock_t clock2 = clock();
    double seconds = ((double)(clock2-clock1))/CLOCKS_PER_SEC;
    printf("%d iterations to %.2f seconds, %.2f iterations/sec\n", 
	   iterations, seconds, ((double)iterations)/seconds);
    PIXEL * line = new PIXEL[parms->width*parms->image_bytes*
			    parms->image_channels];

#define FUNC(i) ((log(i+1)))
#define FUNC2(i) (atan(0.1*i)/HALFPI)

#if 1
    double max = 0;
    for(int i = 0 ; i < parms->height ; i++) 
	for(int j = 0 ; j < parms->width ; j++ )
	    if(attractor[i][j] > max)
		max = attractor[i][j];
#endif
    parms->div /= 130.0;
    
    printf("div is %.10f\n", parms->div*iterations);
    printf("max is %.10f\n", max);
 
    double coef = 255.0/FUNC(((double)iterations) * parms->div);

    for(int i = 0 ; i < parms->height ; i++) {
	if(parms->image_channels == 1)
	    memset(line, 0xFF, 
		   parms->width*parms->image_bytes*parms->image_channels);
	else
	    memset(line, 0x00, 
		   parms->width*parms->image_bytes*parms->image_channels);
	
	if(parms->image_channels == 1)
	    for(int j = 0 ; j < parms->width ; j++)
		BYTE_R(line+j) = 0xFF - 
#if 0
		    (unsigned char)(204*atan(0.008*attractor[i][j])/HALFPI);
#else
	            (unsigned char)(coef*FUNC(attractor[i][j]));
#endif
	else
	    for(int j = 0 ; j < parms->width ; j++) {
		if(attractor[i][j]) {
		    double r, g, b;
		    double h = 360.0/FUNC(((double)iterations)*parms->div)*
			FUNC(attractor[i][j]);
//		    printf("h is %.2f\n", h);
		    hsv_to_rgb(h, 1.0,FUNC2(attractor[i][j])/
			       FUNC2(((double)iterations)*parms->div),
			       &r, &g, &b);
		    BYTE_R(line+j*3) = (unsigned char)(255*r);
		    BYTE_G(line+j*3) = (unsigned char)(255*g);
		    BYTE_B(line+j*3) = (unsigned char)(255*b);
		}
	    }
	
	png_write_rows(parms->png_ptr, (unsigned char **)&line, 1);
	delete [] attractor[i];
    }
    printf("png written to %s\n", parms->filename);
}

int get_next_divergence_block(Parameters * parms) {

  int retval;
#ifdef THREADS
  sem_wait(&parms->diverg_mutex);
  if(parms->currblock != parms->height)
    retval = parms->currblock++;
  else
    retval = -1;
  sem_post(&parms->diverg_mutex);
#endif
  return retval;
}

int get_thread_num(Parameters * parms) {

    int retval;
#ifdef THREADS
    sem_wait(&parms->diverg_mutex);
    retval = parms->currthread++;
    sem_post(&parms->diverg_mutex);
#endif
    return(retval);
}

void * test_divergence(void * _parms) {

  Parameters * parms = (Parameters*)_parms;
  PIXEL *line;
  int block;

  int thread_num = get_thread_num(parms);

  while((block = get_next_divergence_block(parms))!=-1) {
      line = new PIXEL[parms->width*parms->image_bytes*parms->image_channels];
      compute_line(parms, line, block, thread_num);
#ifdef THREADS
      parms->q->insert(line, block);
#endif
  }
#ifdef THREADS
  pthread_exit(0);
#endif
}

void * start_threads(void * _parms) {

  Parameters * parms = (Parameters*)_parms;
  int i;

/*   printf("start_threads\n"); */

#ifdef THREADS
  pthread_t thread[parms->num_threads];
  for(i = 0 ; i < parms->num_threads ; i++)
    pthread_create(&thread[i], NULL, test_divergence, (void *)parms);

  for(i = 0 ; i < parms->num_threads ; i++)
    pthread_join(thread[i], NULL);
/*   printf("joined\n"); */

  parms->q->insert(NULL, parms->height);

/*   parms->q->dump_state(); */
  
  pthread_exit(0);
#endif
}

void compute_line(Parameters * parms, PIXEL * line, int which_line, int which_table) {
  quat pt, line_start;
  double r;
  double a, b;
  int i, pixel_x, iter;
  double log_of_maxpow = log(parms->maxpow);

//  printf("init compute\n");

  line_start.s = parms->min.s+which_line*parms->vstep.s;
  line_start.a = parms->min.a+which_line*parms->vstep.a;
  line_start.b = parms->min.b+which_line*parms->vstep.b;
  line_start.c = parms->min.c+which_line*parms->vstep.c;
  
  for (pixel_x = 0; pixel_x < parms->width; ++pixel_x) {
    iter = 0;
				// maybe do this incrementally
    pt.s = line_start.s + pixel_x * parms->hstep.s; 
    pt.a = line_start.a + pixel_x * parms->hstep.a;
    pt.b = line_start.b + pixel_x * parms->hstep.b;
    pt.c = line_start.c + pixel_x * parms->hstep.c;

				// iterate point
    double v[4];
    v[0] = pt.s;
    v[1] = pt.a;
    v[2] = pt.b;
    v[3] = pt.c;

    iter = (*parms->f)(parms->table[which_table], v);

    r = v[0]*v[0]+v[1]*v[1]+v[2]*v[2]+v[3]*v[3];
    
    if(isnan(r) || isinf(r)) {

	r = parms->bailout;
	fprintf(stderr, "got NaN or INF at point %.5f %.5f\n", pt.s, pt.a);
/* 	exit(-1); */
    }

    int wrapped = 0;

    if(iter < parms->maxiter || parms->color_by_angle) { /* hack!!! */
	if(parms->smooth) {
	    double fuck = sqrt(r);
/* 	    if(fuck < 1.0) */
/* 		b = iter; */
/* 	    else */
	    b = iter - log(log(sqrt(r)))/log_of_maxpow;
	    if(isnan(b) || isinf(b))
		b = iter;
	    a = fabs(fmod(b,parms->limit));
	    
//    	if (a<0) {
// 	    a+=parms->limit;
// 	    wrapped = 1;
// 	}
	} else if(parms->color_by_angle) {
	    a = atan2(v[0], v[1])/(2*3.1415926535897)+0.5;
	    b = iter;
	} else {
	    a = b = iter;
	}

#ifdef COLOR
	a /= parms->limit;	// normalize to (0,1)
				// determine which gradient to use
	int which_gradient = (int)fmod(b/parms->limit, parms->pallete_size);

	char from_color[parms->image_channels*parms->image_bytes];
	char to_color[parms->image_channels*parms->image_bytes];
	char this_color[parms->image_channels*parms->image_bytes];

				// get endpoint colors
	memcpy(from_color, parms->pallete+which_gradient*
	       parms->image_channels*parms->image_bytes,
	       parms->image_channels*parms->image_bytes);

	memcpy(to_color,parms->pallete+((which_gradient+1)%parms->pallete_size)*
	       parms->image_channels*parms->image_bytes,
	       parms->image_channels*parms->image_bytes);

	if(parms->image_channels == 1) {
	    if(parms->image_bytes == 2) {
		WYDE_R(this_color) = a*(WYDE_R(to_color) - WYDE_R(from_color)) + 
		    WYDE_R(from_color);

// 		printf("color = %x\n", WYDE_R(this_color));
		WYDE_R(line+2*pixel_x) = WYDE_R(this_color);
	    } else {
		BYTE_R(this_color) = a*(BYTE_R(to_color) - BYTE_R(from_color)) + 
		    BYTE_R(from_color);
		
		BYTE_R(line+pixel_x) = BYTE_R(this_color);
	    }
	} else {
	    if(parms->image_bytes == 2) {
		WYDE_R(this_color) = a*(WYDE_R(to_color) - WYDE_R(from_color)) + 
		    WYDE_R(from_color);
		WYDE_G(this_color) = a*(WYDE_G(to_color) - WYDE_G(from_color)) + 
		    WYDE_G(from_color);
		WYDE_B(this_color) = a*(WYDE_B(to_color) - WYDE_B(from_color)) + 
		    WYDE_B(from_color);
		
		WYDE_R(line+pixel_x*6) = WYDE_R(this_color);
		WYDE_G(line+pixel_x*6) = WYDE_G(this_color);
		WYDE_B(line+pixel_x*6) = WYDE_B(this_color);
	    } else {
		BYTE_R(this_color) = a*(BYTE_R(to_color) - BYTE_R(from_color)) + 
		    BYTE_R(from_color);
		BYTE_G(this_color) = a*(BYTE_G(to_color) - BYTE_G(from_color)) + 
		    BYTE_G(from_color);
		BYTE_B(this_color) = a*(BYTE_B(to_color) - BYTE_B(from_color)) + 
		    BYTE_B(from_color);
		
		BYTE_R(line+pixel_x*3) = BYTE_R(this_color);
		BYTE_G(line+pixel_x*3) = BYTE_G(this_color);
		BYTE_B(line+pixel_x*3) = BYTE_B(this_color);
	    }
	}

#endif
    } else {
#ifdef COLOR
	if(parms->image_channels == 1) 
	    if(parms->image_bytes == 1) 
		BYTE_R(line+pixel_x) = 0x00;
	    else 
		WYDE_R(line+2*pixel_x) = 0x0000;
	else {
	    if(parms->image_bytes == 1) {
		BYTE_R(line+pixel_x*3) = 0x00;
		BYTE_G(line+pixel_x*3) = 0x00;
		BYTE_B(line+pixel_x*3) = 0x00;
	    } else {
		WYDE_R(line+pixel_x*6) = 0x0000;
		WYDE_G(line+pixel_x*6) = 0x0000;
		WYDE_B(line+pixel_x*6) = 0x0000;
	    }
	}

#else
	line[parms->image_bytes*pixel_x] = (PIXEL)0x0000;
#endif

    }    
  }

//  printf("exit_compute\n");
}

void init_png(Parameters * parms) {

  parms->png_file = fopen(parms->filename, "wb");
  
  if(!parms->png_file) {
      fprintf(stderr, "couldn't open file %s\n", parms->filename);
      exit(-1);
  }

  parms->png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, 
					   NULL, NULL, NULL);
  parms->info_ptr = png_create_info_struct(parms->png_ptr);
 
  if(!parms->info_ptr) {
    fprintf(stderr, "failed to create png struct\n");
    exit(-1);
  }

  if(setjmp(parms->png_ptr->jmpbuf)) {
    fprintf(stderr, "error.  exiting\n");
    exit(-1);
  }

  png_init_io(parms->png_ptr, parms->png_file);
  png_set_IHDR(parms->png_ptr, parms->info_ptr, parms->width, parms->height,
	       parms->image_bits, 
	       (parms->image_channels == 3) ? PNG_COLOR_TYPE_RGB : 
	       PNG_COLOR_TYPE_GRAY,
	       PNG_INTERLACE_NONE,
	       PNG_COMPRESSION_TYPE_DEFAULT,
	       PNG_FILTER_TYPE_DEFAULT);
  png_write_info(parms->png_ptr, parms->info_ptr);
  png_set_swap(parms->png_ptr);	/* only on little endian ;< */
}

void load_pallete(Parameters * parms) {
    
    double buf[1024];		// probably big enough..
    int i = 0;
    int maxval = (1<<parms->image_bits)-1; // this is white ?

    FILE * fp = fopen(parms->pallete_file, "r");

    if(!fp) {
	printf("could not open pallete file %s\n", parms->pallete_file);
	exit(-1);
    }
    
    if(parms->image_channels == 3) {
	while(fscanf(fp, " { %lf %lf %lf } ", &buf[i], &buf[i+1], &buf[i+2])==3)
	    i+=3;
	i/=3;
    } else while(fscanf(fp, " { %lf } ", &buf[i])==1) i++;

    parms->pallete_size = i;

    if(i<2) {
	printf("pallete of size 1 will yield solid image\n");
	printf("might I suggest using bucket fill in the gimp instead?\n");
	exit(-1);
    }

    parms->pallete = new BYTE[i*parms->image_bytes*parms->image_channels];

//     printf("max is %x\n", (1<<(parms->image_bits))-1);

    for(int j = 0 ; j < i ; j++) 
	if(parms->image_channels == 1)
	    if(parms->image_bytes == 1)
		BYTE_R(parms->pallete+j) = (BYTE)(buf[j]*maxval);
	    else
		WYDE_R(parms->pallete+j*2) = (WYDE)(buf[j]*maxval);
	else
	    if(parms->image_bytes == 1) {
		BYTE_R(parms->pallete+j*3) = (BYTE)(buf[j*3]*maxval);
		BYTE_G(parms->pallete+j*3) = (BYTE)(buf[j*3+1]*maxval);
		BYTE_B(parms->pallete+j*3) = (BYTE)(buf[j*3+2]*maxval);
	    } else {
		WYDE_R(parms->pallete+j*6) = (WYDE)(buf[j*3]*maxval);
		WYDE_G(parms->pallete+j*6) = (WYDE)(buf[j*3+1]*maxval);
		WYDE_B(parms->pallete+j*6) = (WYDE)(buf[j*3+2]*maxval);
	    }
}

void				/* from gtk_colorselection */
hsv_to_rgb (double  h, double  s, double  v,
	    double *r, double *g, double *b)
{
  int i;
  double f, w, q, t;

  if (s == 0.0)
    s = 0.000001;

  if (h == -1.0)
    {
      *r = v;
      *g = v;
      *b = v;
    }
  else
    {
      if (h == 360.0)
	h = 0.0;
      h = h / 60.0;
      i = (int) h;
      f = h - i;
      w = v * (1.0 - s);
      q = v * (1.0 - (s * f));
      t = v * (1.0 - (s * (1.0 - f)));

      switch (i)
	{
	case 0:
	  *r = v;
	  *g = t;
	  *b = w;
	  break;
	case 1:
	  *r = q;
	  *g = v;
	  *b = w;
	  break;
	case 2:
	  *r = w;
	  *g = v;
	  *b = t;
	  break;
	case 3:
	  *r = w;
	  *g = q;
	  *b = v;
	  break;
	case 4:
	  *r = t;
	  *g = w;
	  *b = v;
	  break;
	case 5:
	  *r = v;
	  *g = w;
	  *b = q;
	  break;
	}
    }
}

