#include <gtk/gtk.h>


/*
  TO DO: 
  * Instead of the vertical path to files listing, make a menu
    with the cool direcotry picker.
*/

typedef struct BFEwidgets 
{
  GtkWidget *binpath;
  GtkWidget *palpath;
  GtkWidget *savpath;

  GtkWidget *channels;
  GtkWidget *palette;
  GtkWidget *limit;

  GtkWidget *iterations;
  GtkWidget *bailout;
  GtkWidget *function;
  GtkWidget *maxpow;

  GtkWidget *center;
  GtkWidget *span;
  GtkWidget *xline;
  GtkWidget *yline;

  GtkWidget *size;
  GtkWidget *filename;
  
}  BFEwidgets;


/* Quit function */
void delete_event (GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gtk_main_quit ();
}


/* 
  In: Box in which this BigEntryBox will go.
       Text label for the box.
 Out: box in which entry widgets are to be stored in.
*/
GtkWidget * MakeBigEntryBox (GtkWidget *motherbox, char* labeltext, char vertical)
{
  GtkWidget *bigentrybox;
  GtkWidget *labelbox;
  GtkWidget *label;
  GtkWidget *separation;
  GtkWidget *sepbox;
  GtkWidget *entrybox;
  
  /* create/pack/show big entry box */
  bigentrybox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (motherbox), bigentrybox, FALSE, FALSE, 0);
  gtk_widget_show (bigentrybox);

  /* create/pack/show label box */
  labelbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bigentrybox), labelbox, FALSE, FALSE, 0);
  gtk_widget_show (labelbox);

  /* create/pack/show label */
  label = gtk_label_new (labeltext);
  gtk_box_pack_start (GTK_BOX (labelbox), label, FALSE, FALSE, 0);
  gtk_widget_show (label);

  /* create/pack/show sepbox */
  sepbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bigentrybox), sepbox, FALSE, FALSE, 0);
  gtk_widget_show (sepbox);

  /* create/pack/show separator */
  separation = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (sepbox), separation, TRUE, TRUE, 0);
  gtk_widget_show (separation);

  /* create/pack/show entrybox */
  if (vertical == 1)
    entrybox = gtk_vbox_new (FALSE, 0);
  else
    entrybox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bigentrybox), entrybox, FALSE, FALSE, 4);
  gtk_widget_show (entrybox);

  return (entrybox);
}


GtkWidget * MakeLabeledEntry (GtkWidget *box, char *labeltext, int length, const gchar *initial) 
{
  GtkWidget *label;
  GtkWidget *entry;

  label = gtk_label_new (labeltext);
  gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 5);
  gtk_widget_show (label);

  entry = gtk_entry_new_with_max_length (length);
  if (length < 30)
    gtk_widget_set_usize (GTK_WIDGET (entry), length * 5 + 10, 22);
  else
    gtk_widget_set_usize (GTK_WIDGET (entry), 160, 22);
  gtk_entry_append_text ((GtkEntry *) entry, initial);
  gtk_box_pack_start (GTK_BOX (box), entry, FALSE, FALSE, 0);
  gtk_widget_show (entry);

  return (entry);
}


void RunBFE (GtkWidget *widget, BFEwidgets *parms)
{
  char runline[256];

  sprintf(runline, "(%s/bfe -nt 4 -ic %s -pf %s/%s -l %s -i %s -p %s -b %s -F '%s' -center %s -span %s -hv %s -vv %s -size %s -f %s/%s && xv %s/%s )&", 
	  gtk_entry_get_text((GtkEntry *) parms-> binpath    ),
	  gtk_entry_get_text((GtkEntry *) parms-> channels   ),
	  gtk_entry_get_text((GtkEntry *) parms-> palpath    ),
	  gtk_entry_get_text((GtkEntry *) parms-> palette    ),
	  gtk_entry_get_text((GtkEntry *) parms-> limit      ),
	  gtk_entry_get_text((GtkEntry *) parms-> iterations ),
	  gtk_entry_get_text((GtkEntry *) parms-> maxpow     ),
	  gtk_entry_get_text((GtkEntry *) parms-> bailout    ),
	  gtk_entry_get_text((GtkEntry *) parms-> function   ),
	  gtk_entry_get_text((GtkEntry *) parms-> center     ),
	  gtk_entry_get_text((GtkEntry *) parms-> span       ),
	  gtk_entry_get_text((GtkEntry *) parms-> xline      ),
	  gtk_entry_get_text((GtkEntry *) parms-> yline      ),
	  gtk_entry_get_text((GtkEntry *) parms-> size       ),
	  gtk_entry_get_text((GtkEntry *) parms->savpath  ),
	  gtk_entry_get_text((GtkEntry *) parms-> filename   ),
	  gtk_entry_get_text((GtkEntry *) parms->savpath  ),
	  gtk_entry_get_text((GtkEntry *) parms-> filename   ));

  printf("\nsystem: %s\n", runline);
  system(runline);
}



int main (int argc, char *argv[])
{
  /* -- Declare Widgets -- */
  GtkWidget *window;
  GtkWidget *button;

  BFEwidgets *bfeparms;
  GtkWidget *palette;

  GtkWidget *windowbox;
  GtkWidget *entrybox;
  GtkWidget *buttonbox;

  char text[32] = "This is a test.";

  gtk_init (&argc, &argv);


  printf("--- A ---\n");


  /* main window */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "BFE/Gtk");
  gtk_container_border_width (GTK_CONTAINER (window), 8);

  /* window manager close event */
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (delete_event), NULL);
  

  /* the main window box */
  windowbox = gtk_vbox_new (FALSE, 8);
  gtk_container_add (GTK_CONTAINER (window), windowbox);


  /* PATHS entries */
  entrybox = MakeBigEntryBox(windowbox, "Path to Files", 0);
  bfeparms->binpath = MakeLabeledEntry (entrybox, "binary executable:", 128, ".");
  bfeparms->palpath = MakeLabeledEntry (entrybox, "color palettes:", 128, "/home/brainsik/fract/bfe/");
  bfeparms->savpath = MakeLabeledEntry (entrybox, "save directory:", 128, "/tmp");

  /* COLORING entries */
  entrybox = MakeBigEntryBox(windowbox, "Coloring", 0);
  bfeparms->channels = MakeLabeledEntry (entrybox, " channels:", 1, "3");
  bfeparms->palette  = MakeLabeledEntry (entrybox, " palette:", 128, "pallete");
  bfeparms->limit    = MakeLabeledEntry (entrybox, " limit:", 5, "1");

  /* CALCULATION entries */
  entrybox = MakeBigEntryBox(windowbox, "Calculations", 0);
  bfeparms->iterations = MakeLabeledEntry (entrybox, " iterations:", 5, "512");
  bfeparms->bailout    = MakeLabeledEntry (entrybox, " bailout:", 5, "512");
  bfeparms->maxpow     = MakeLabeledEntry (entrybox, " maxpow:", 2, "2");
  bfeparms->function   = MakeLabeledEntry (entrybox, " function:", 256, "q^2+c");

  /* VIEW entries */
  entrybox = MakeBigEntryBox(windowbox, "View", 0);
  bfeparms->center = MakeLabeledEntry (entrybox, " center:", 20, "-0.5 0 0 0");
  bfeparms->span   = MakeLabeledEntry (entrybox, " span:", 20, "3 3");
  bfeparms->xline  = MakeLabeledEntry (entrybox, " x-line:", 20, "1 0 0 0");
  bfeparms->yline  = MakeLabeledEntry (entrybox, " y-line:", 20, "0 1 0 0");

  /* IMAGE entries */
  entrybox = MakeBigEntryBox(windowbox, "Image", 0);
  bfeparms->size     = MakeLabeledEntry (entrybox, " size:", 10, "200 200");
  bfeparms->filename = MakeLabeledEntry (entrybox, " filename:", 128, "test.png");


  /* button box */
  buttonbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (windowbox), buttonbox, FALSE, FALSE, 0);
  gtk_widget_show (buttonbox);

  /* Quit button */
  button = gtk_button_new_with_label ("Quit");
  gtk_box_pack_end(GTK_BOX (buttonbox), button, FALSE, FALSE, 8);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (delete_event), NULL);

  /* Generate Button */
  button = gtk_button_new_with_label ("Generate");
  gtk_box_pack_end(GTK_BOX (buttonbox), button, FALSE, FALSE, 8);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (RunBFE), bfeparms);
  


  gtk_widget_show (windowbox);
  gtk_widget_show (window);
  gtk_main ();

  return 0;

}
  
