#include <gtk/gtk.h>

typedef struct BFEwidgets 
{
  GtkWidget *binpath;
  GtkWidget *palpath;
  GtkWidget *savpath;
  GtkWidget *threads;

  GtkWidget *channels;
  GtkWidget *palette;
  GtkWidget *limit;

  GtkWidget *iterations;
  GtkWidget *bailout;
  GtkWidget *function;
  GtkWidget *maxpow;

  GtkWidget *center;
  GtkWidget *span;
  GtkWidget *xline;
  GtkWidget *yline;

  GtkWidget *size;
  GtkWidget *filename;
  
}  BFEwidgets;


GtkWidget * MakeLabeledEntry (GtkWidget *box, char *labeltext, int length, const gchar *initial) 
{
  GtkWidget *thisbox;
  GtkWidget *label;
  GtkWidget *entry;

  thisbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (thisbox);
  gtk_box_pack_start (GTK_BOX (box), thisbox, FALSE, FALSE, 5);

  label = gtk_label_new (labeltext);
  gtk_box_pack_start (GTK_BOX (thisbox), label, FALSE, FALSE, 5);
  gtk_widget_show (label);

  entry = gtk_entry_new_with_max_length (length+8);
  /*
  if (length == 1)
    gtk_widget_set_usize(entry, 16, 22);
  else
    if (length == 2)
      gtk_widget_set_usize(entry, 23, 22);
  */

  /*
  if (length < 42)
    gtk_widget_set_usize(entry, 9 + (7 * length), 22);
  */

  gtk_entry_set_text ((GtkEntry *) entry, initial);
  gtk_box_pack_start (GTK_BOX (thisbox), entry, TRUE, TRUE, 0);
  gtk_widget_show (entry);

  return (entry);
}

void RunBFE (GtkWidget *widget, BFEwidgets *parms)
{
  char runline[256];

  printf ("\nThe elixir is ready...\n");

  sprintf(runline, "(%s/bfe -nt %s -ic %s -pf %s/%s -l %s -i %s -p %s -b %s -F '%s' -center %s -span %s -hv %s -vv %s -size %s -f %s/%s && xv %s/%s )&", 
	  gtk_entry_get_text((GtkEntry *) parms-> binpath    ),
	  gtk_entry_get_text((GtkEntry *) parms-> threads    ),
	  gtk_entry_get_text((GtkEntry *) parms-> channels   ),
	  gtk_entry_get_text((GtkEntry *) parms-> palpath    ),
	  gtk_entry_get_text((GtkEntry *) parms-> palette    ),
	  gtk_entry_get_text((GtkEntry *) parms-> limit      ),
	  gtk_entry_get_text((GtkEntry *) parms-> iterations ),
	  gtk_entry_get_text((GtkEntry *) parms-> maxpow     ),
	  gtk_entry_get_text((GtkEntry *) parms-> bailout    ),
	  gtk_entry_get_text((GtkEntry *) parms-> function   ),
	  gtk_entry_get_text((GtkEntry *) parms-> center     ),
	  gtk_entry_get_text((GtkEntry *) parms-> span       ),
	  gtk_entry_get_text((GtkEntry *) parms-> xline      ),
	  gtk_entry_get_text((GtkEntry *) parms-> yline      ),
	  gtk_entry_get_text((GtkEntry *) parms-> size       ),
	  gtk_entry_get_text((GtkEntry *) parms->savpath  ),
	  gtk_entry_get_text((GtkEntry *) parms-> filename   ),
	  gtk_entry_get_text((GtkEntry *) parms->savpath  ),
	  gtk_entry_get_text((GtkEntry *) parms-> filename   ));

  /*  gtk_entry_set_text ((GtkEntry *) parms->function, "0"); */

  printf("\nNow go eat shit...\n");

  printf("\nsystem: %s\n", runline);

  printf("\nDeprecate your mother.\n");
  system(runline);
  printf("\nThe elixir is gone.\n");
}

void delete_event (GtkWidget *widget, GdkEvent *event)
{
  gtk_main_quit ();
}

int main (int argc, char *argv[])
{
  GtkWidget *window;
  GtkWidget *windowbox;

  GtkWidget *buttonbox;
  GtkWidget *button;

  GtkWidget *notebook;
  GtkWidget *label;
  GtkWidget *entrybox;

  BFEwidgets bfeparms;

  /*
  GtkWidget *window;
  GtkWidget *button;

  BFEwidgets *bfeparms;
  GtkWidget *palette;

  GtkWidget *notebook;
  GtkWidget *page;

  GtkWidget *frame;
  GtkWidget *label;

  GtkWidget *windowbox;
  GtkWidget *entrybox;
  GtkWidget *buttonbox;
  */


  gtk_init (&argc, &argv);

  /* main window */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "BFE/Gtk");
  gtk_container_border_width (GTK_CONTAINER (window), 8);

  /* window manager close event */
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (delete_event), NULL);

  /* the main window box */
  windowbox = gtk_vbox_new (FALSE, 8);
  gtk_container_add (GTK_CONTAINER (window), windowbox);

  /* main entry notebook */
  notebook = gtk_notebook_new ();
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_LEFT);
  gtk_widget_show(notebook);
  gtk_box_pack_start (GTK_BOX (windowbox), notebook, FALSE, FALSE, 0);

  /* --- entry Notebook Pages --- */

  label = gtk_label_new ("System");
  entrybox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (entrybox);
  bfeparms.binpath = MakeLabeledEntry (entrybox, " binary path:", 128, ".");
  bfeparms.palpath = MakeLabeledEntry (entrybox, "pallete path:", 128, ".");
  bfeparms.savpath = MakeLabeledEntry (entrybox, "   save path:", 128, "/tmp");
  bfeparms.threads = MakeLabeledEntry (entrybox, "# of threads:", 1, "1");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), entrybox, label);

  label = gtk_label_new ("Coloring");
  entrybox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (entrybox);
  bfeparms.channels = MakeLabeledEntry (entrybox, " channels:", 1, "3");
  bfeparms.palette  = MakeLabeledEntry (entrybox, " palette:", 128, "palette");
  bfeparms.limit    = MakeLabeledEntry (entrybox, " limit:", 5, "8");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), entrybox, label);

  label = gtk_label_new ("Image");
  entrybox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (entrybox);
  bfeparms.size     = MakeLabeledEntry (entrybox, " size:", 10, "200 200");
  bfeparms.filename = MakeLabeledEntry (entrybox, " filename:", 128, "test.png");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), entrybox, label);

  label = gtk_label_new ("View");
  entrybox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (entrybox);
  bfeparms.center = MakeLabeledEntry (entrybox, " center:", 20, "-0.5 0 0 0");
  bfeparms.span   = MakeLabeledEntry (entrybox, " span:", 20, "3 3");
  bfeparms.xline  = MakeLabeledEntry (entrybox, " x-line:", 20, "1 0 0 0");
  bfeparms.yline  = MakeLabeledEntry (entrybox, " y-line:", 20, "0 1 0 0");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), entrybox, label);

  label = gtk_label_new ("Calculations");
  entrybox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (entrybox);
  bfeparms.iterations = MakeLabeledEntry (entrybox, " iterations:", 5, "512");
  bfeparms.bailout    = MakeLabeledEntry (entrybox, " bailout:", 5, "512");
  bfeparms.maxpow     = MakeLabeledEntry (entrybox, " maxpow:", 2, "2");
  bfeparms.function   = MakeLabeledEntry (entrybox, " function:", 512, "q^2+c");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), entrybox, label);

  /* --- -------------------- --- */


  /* button box */
  buttonbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (windowbox), buttonbox, FALSE, FALSE, 0);
  gtk_widget_show (buttonbox);

  /* Quit button */
  button = gtk_button_new_with_label ("Quit");
  gtk_box_pack_end(GTK_BOX (buttonbox), button, FALSE, FALSE, 8);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (delete_event), NULL);

  /* Generate Button */
  button = gtk_button_new_with_label ("Generate");
  gtk_box_pack_end(GTK_BOX (buttonbox), button, FALSE, FALSE, 8);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (RunBFE), &bfeparms);
  
  printf("\nCreate legions of rye.\n");

  gtk_widget_show (windowbox);
  gtk_widget_show (window);

  printf("\nSmoke the bowling ball.\n");

  gtk_main ();

  printf("\nPark the Car!\n");

  return 0;

}
  
