#!/usr/bin/perl -w

use Gtk;
init Gtk;

use strict;

&create_notebook;
Gtk::main Gtk;

my $version = "v0.01";

my %bfeparms = (
		binary => '',
		palpath => '',
		savpath => '',
		threads => '',
		
		channels => '',
		palette => '',
		limit => '',
		
		iterations => '',
		bailout => '',
		maxpow => '',
		function => '',
		
		center => '',
		span => '',
		horz => '',
		vert => '',
		
		size => '',
		filename => ''
	       );

my $notebook_window;

sub run_bfe() {

  my $runline = 
    sprintf("(%s -nt %s -ic %s -pf %s/%s -l %s -i %s -p %s -b %s -F '%s' -center %s -span %s -hv %s -vv %s -size %s -f %s/%s && xv %s/%s )&", 
	    $bfeparms{'binary'}->get_text,
	    $bfeparms{'threads'}->get_text,
	    $bfeparms{'channels'}->get_text,
	    $bfeparms{'palpath'}->get_text,
	    $bfeparms{'palette'}->get_text,
	    $bfeparms{'limit'}->get_text,
	    $bfeparms{'iterations'}->get_text,
	    $bfeparms{'maxpow'}->get_text,
	    $bfeparms{'bailout'}->get_text,   
	    $bfeparms{'function'}->get_text,  
	    $bfeparms{'center'}->get_text,    
	    $bfeparms{'span'}->get_text,      
	    $bfeparms{'horz'}->get_text,     
	    $bfeparms{'vert'}->get_text,     
	    $bfeparms{'size'}->get_text,    
	    $bfeparms{'savpath'}->get_text,  
	    $bfeparms{'filename'}->get_text, 
	    $bfeparms{'savpath'}->get_text,  
	    $bfeparms{'filename'}->get_text); 
  
  print "\n$runline\n";
  system $runline;
}

sub notebook_page_switch {
  my( $widget, $new_page, $page_num) = @_;
  
  my $old_page = $widget->cur_page();
  if ( defined $old_page ) {
    if ($new_page == $old_page) {
      return;
    }
  }
  
  my $new_page_tab_pixmap = ($new_page->tab_label->children)[0]->widget;
  my $new_page_menu_pixmap = ($new_page->menu_label->children)[0]->widget;
  
  if ( defined $old_page ) {
    my $old_page_tab_pixmap = ($old_page->tab_label->children)[0]->widget;
    my $old_page_menu_pixmap = ($old_page->menu_label->children)[0]->widget;
  }
}


sub labeled_entry {
  my(
     $box,
     $labeltext,
     $length,
     $initval
     ) = @_;

  my(
     $entrybox,
     $label,
     $entry
     );

  $entrybox = new Gtk::HBox(0,0);
  $box->pack_start($entrybox, 0, 0, 5);
  
  $label = new Gtk::Label($labeltext);
  $entrybox->pack_start($label, 0, 0, 5);

  $entry = new Gtk::Entry;
  $entry->set_text($initval);
  $entrybox->pack_start($entry, 1, 1, 0);
  
  return($entry);
}
  

sub notebook_create_pages {
  my( $notebook ) = shift;
  
  my(
     $popupmenubox,
     $popupmenulabel,

     $pagebox,
     $pagelabel,
     $pagelabelbox
    );

  $popupmenubox = new Gtk::HBox( 0, 0 );
  $popupmenulabel = new Gtk::Label("Where are the popups?") ;
  $popupmenubox->pack_start( $popupmenulabel, 0, 1, 0 );
  $popupmenubox->show_all();

  $pagelabel = new Gtk::Label "System";
  $pagelabelbox = new Gtk::HBox(0,0);
  $pagelabelbox->pack_start($pagelabel, 0, 1, 0);
  $pagelabelbox->show_all;
  $pagebox = new Gtk::VBox(0,0);
  $bfeparms{'binary'}  = labeled_entry($pagebox,"binary:",128,"./bfe");
  $bfeparms{'threads'} = labeled_entry($pagebox,"threads:",128,"4");
  $bfeparms{'palpath'} = labeled_entry($pagebox,"pallete path:",128,".");
  $bfeparms{'savpath'} = labeled_entry($pagebox,"save path:",128,"/tmp");
  $pagebox->show_all();
  $notebook->append_page_menu($pagebox, $pagelabelbox, $popupmenubox);

  $pagelabel = new Gtk::Label "Coloring";
  $pagelabelbox = new Gtk::HBox(0,0);
  $pagelabelbox->pack_start($pagelabel, 0, 1, 0);
  $pagelabelbox->show_all;
  $pagebox = new Gtk::VBox(0,0);
  $bfeparms{'channels'} = labeled_entry($pagebox,"channels:",1,"3");
  $bfeparms{'palette'} = labeled_entry($pagebox,"palette:",128,"palette");
  $bfeparms{'limit'} = labeled_entry($pagebox, "limit:",4,"8");
  $pagebox->show_all();
  $notebook->append_page_menu($pagebox, $pagelabelbox, $popupmenubox);

  $pagelabel = new Gtk::Label "Image";
  $pagelabelbox = new Gtk::HBox(0,0);
  $pagelabelbox->pack_start($pagelabel, 0, 1, 0);
  $pagelabelbox->show_all;
  $pagebox = new Gtk::VBox(0,0);
  $bfeparms{'filename'} = labeled_entry($pagebox,"filename:",128,"bfeimg.png");
  $bfeparms{'size'} = labeled_entry($pagebox,"size:",10,"250 250");
  $pagebox->show_all();
  $notebook->append_page_menu($pagebox, $pagelabelbox, $popupmenubox);

  $pagelabel = new Gtk::Label "Calculations";
  $pagelabelbox = new Gtk::HBox(0,0);
  $pagelabelbox->pack_start($pagelabel, 0, 1, 0);
  $pagelabelbox->show_all;
  $pagebox = new Gtk::VBox(0,0);
  $bfeparms{'bailout'} = labeled_entry($pagebox,"bailout:",5,"4");
  $bfeparms{'iterations'} = labeled_entry($pagebox,"iterations:",6,"256");
  $bfeparms{'maxpow'} = labeled_entry($pagebox,"maxpow:",4,"3");
  $bfeparms{'function'} = labeled_entry($pagebox,"function:",256,"q^2-c");
  $pagebox->show_all();
  $notebook->append_page_menu($pagebox, $pagelabelbox, $popupmenubox);

  $pagelabel = new Gtk::Label "View";
  $pagelabelbox = new Gtk::HBox(0,0);
  $pagelabelbox->pack_start($pagelabel, 0, 1, 0);
  $pagelabelbox->show_all;
  $pagebox = new Gtk::VBox(0,0);
  $bfeparms{'horz'} = labeled_entry($pagebox,"horz:",40,"1 0 0 0");
  $bfeparms{'vert'} = labeled_entry($pagebox,"vert:",40,"0 1 0 0");
  $bfeparms{'center'} = labeled_entry($pagebox,"center:",40,"0 0 0 0");
  $bfeparms{'span'} = labeled_entry($pagebox,"span:",22,"2.5 2.5");
  $pagebox->show_all();
  $notebook->append_page_menu($pagebox, $pagelabelbox, $popupmenubox);
}

sub create_notebook {
  my(
     $box1,
     $box2,
     $button,
     $separator,
     $notebook,
     $omenu,
     $menu,
     $submenu,
     $menuitem,
     $group,
     $transparent
    );
  
  if (not defined $notebook_window) {
    
    $notebook_window = new Gtk::Window( 'toplevel' );
    $notebook_window->signal_connect( 'destroy', \&Gtk::main_quit);
    $notebook_window->signal_connect( 'delete_event', \&Gtk::false);
    $notebook_window->set_title("BFE/GtkPerl $version");
    $notebook_window->border_width(0);
    
    $box1 = new Gtk::VBox 0, 0;
    $notebook_window->add($box1);
    
    $notebook = new Gtk::Notebook;
#    $notebook->signal_connect( 'switch_page', \&notebook_page_switch );
    $notebook->set_tab_pos("left");
    $box1->pack_start($notebook, 1, 1, 0);
    $notebook->border_width(10);
    
    notebook_create_pages($notebook);
    
#    $separator = new Gtk::HSeparator();
#    $box1->pack_start( $separator, 0, 1, 10 );
    
    $box2 = new Gtk::HBox( 0, 0 );
    $box1->pack_start( $box2, 0, 0, 0 );
    
#    $omenu = new Gtk::OptionMenu();
#    $menu = new Gtk::Menu();
#    $submenu = undef;
#    $menuitem = undef;
    
#    $menuitem = new Gtk::RadioMenuItem "Standard", $menuitem;
#    $menuitem->signal_connect("activate", \&notebook_standard, $notebook);
#    $menu->append($menuitem);
#    $menuitem->show;
    
    $box2 = new Gtk::HBox 0, 0;
    $box2->border_width(5);
    $box1->pack_start($box2, 0, 0, 0);
    
    $button = new Gtk::Button( 'Generate' );
    $button->signal_connect( 'clicked', \&run_bfe );
    $box2->pack_end( $button, 1, 1, 5);

    $button = new Gtk::Button( 'Quit' );
    $button->signal_connect( 'clicked', \&Gtk::main_quit );
    $box2->pack_end( $button, 1, 1, 5);
  }
  
  if (! $notebook_window->visible) {
    $notebook_window->show_all();
  } else {
    $notebook_window->destroy();
  }
}

