/*
 *  queue.h
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef QUEUE_H
#define QUEUE_H

#include <semaphore.h>
#include <queue>

/*
  this is a synchronized queue implemented with an heap
  
  remove() blocks until the queue is non empty
  insert() signals wait

   it is assumed that only one thread at a time will insert, and only one will 
  remove.  (no mutex) (maybe there should be)
*/

#define MAX_PRIO 99999999

template <class T>
class queue_node {

public:
	
    T * line;
    int position;
    int prio;

    int operator <(const queue_node<T> &other) const {
//	printf("fucking shit!!!\n");
 	return(prio<other.prio);
    }
    
    void dump() {
	printf("node %p %d\n", line, position);
	
 //    if(next)
//       next->dump();
//     else
//       printf("that's all folks!\n");
  }
};

// operator <(class queue_node<T> * one, queue_node<T> * two) {
//     printf("hello there\n");
//     return(one->position<two->position);
// }

template <class T>
class Queue {

private:
  
    int count;

    sem_t ready;
    sem_t mutex;

public:


    priority_queue<queue_node<T> > Q;

    Queue(int num_elems) {
	count = 0;
	sem_init(&ready, 0, 0);
	sem_init(&mutex, 0, 1);
    }

    void insert(T * what, int position) {
	
 	sem_wait(&mutex);
// 	printf("insert %p %d\n", what, position);

	queue_node<T> * new_node = new queue_node<T>;

	new_node->line = what;
	new_node->position = position;
	new_node->prio = MAX_PRIO - position;
//	printf("node has prio %d\n", new_node->prio);
	
	Q.push(*new_node);
	
	if(Q.top().position == count) {
//	    printf("%d ready\n", count);
	    count++;
 	    sem_post(&ready);
	}
// 	printf("front = %p\n", front);
 	sem_post(&mutex);
// 	printf("leave insert\n");
    }
    
    T * remove() {	// assumed that top of queue is what we want
 	sem_wait(&ready);
 	sem_wait(&mutex);
	
	queue_node<T> & old_node = const_cast<queue_node<T>& >(Q.top());

//	printf("removing %d\n", old_node.position);

	T * ans = old_node.line;
	
	Q.pop();
//	delete &old_node;	// wtf?  this sucks
    
	if(!Q.empty() && Q.top().position == count) {
//	    printf("%d ready in remove\n", count);
	    count++;
	    sem_post(&ready);
	}

// 	printf("remove done\n");
 	sem_post(&mutex);

	return ans;
    }
    
    void dump_state() {
// 	if(front)
// 	    front->dump();
// 	else
// 	    printf("empty\n");
    }

};





#endif
