#ifndef PVWIN_H
#define PVWIN_H
#ifdef IRIX_SUCKS		/* should use autoconf */
#include "time.h"
#endif
#include <gtk/gtk.h>
#include "pbfe.h"
#include "splat.h"

extern gint display_fractal(gpointer d);
extern void * start_threads(void * _parms);

class preview_window  {

private:
    
    Parameters * parms;
    GdkRectangle r;    
    int points;
    int ** iter_buffer;
    PIXEL ** image;
    float ** attractor;
    bool keep_going;
    bool attractor_mode;
    bool sound_playing;
    bool attractor_computing;
    double c1, c2, c3, c4, c5, c6;
    FILE * fp;			/* for csound */
    Splat * s;

    GtkObject * tempo_adj;
    GtkWidget ** instruments;
    GtkWidget ** overlap;

    double x_coord, y_coord;

public:

    GtkWidget * win;
    GtkWidget * prev;

    preview_window(Parameters* parms, GtkPreviewType type);
    ~preview_window() { pclose(fp); }
    gint handle_mouse_down(GdkEventButton *);
    gint handle_mouse_up(GdkEventButton *);
    gint handle_key(GdkEventKey *); 
    gint handle_move(GdkEventMotion *);
    void iterate_point(double x, double y);
    void iterate_point_much(double x, double y);
    void iterate_midi(double x, double y);
    void draw_point(double x, double y, unsigned char * color, int iters,
		    double alpha);
    void draw_attractor_point(double x, double y);
    void grab_image();
    void get_attractor_grey(float weight, PIXEL * im);
    void get_attractor_color(float weight, PIXEL * im);
    void hsv_to_rgb(double h, double s, double v, 
		    double *r, double* g, double* b);
    void sonify_attractor(double x, double y);

};

#endif
