#include "splat.h"
#include "math.h"

Splat::Splat(double _sigma, double thresh, int _size) {
    
    sigma = _sigma;
    sigma_sq = sigma*sigma;
    size = _size;

    coef1 = 1.0/(2*3.1415926535*sigma_sq);
    coef2 = 1.0/(2*sigma_sq);

    values = new float*[size];
    for(int i = 0 ; i < size ; i++)
	values[i] = new float[size];
	
    span = sqrt(-2*sigma_sq*log(2*3.141592653589*thresh*sigma_sq))*2;

    delta = span/size;
    delta_sq = delta*delta;

				// fill in values[0][0]
    double latest = thresh;
    double start_x, start_y;
    double curr_x, curr_y;
    int count = 0;

    curr_y = curr_x = start_y = start_x = -span/2+delta/2;
				// maybe pull out delta_sq until later..
    values[0][0] = latest = func_at(curr_x, curr_y)*delta_sq;
    
    while(latest > thresh*thresh) {
	count++;
	curr_x -= delta;
	latest = func_at(curr_x, curr_y)*delta_sq; 
	values[0][0] += latest;
    }
    for(int i = 0 ; i < count ; i++) {
    curr_y -= delta;
    curr_x = start_x;
	for(int j = 0 ; j <= count ; j++) {
	    values[0][0] += func_at(curr_x, curr_y)*delta_sq;
	    curr_x -= delta;
	}
    }

				// now do values[0][1-size]
    curr_y = start_y;
    for(int i = 1 ; i < size ; i++) {
	curr_x = start_x;
	curr_y += delta;
	latest = thresh;
	values[0][i] = values[0][i-1];
	while(latest > thresh*thresh) {
	    latest = func_at(curr_x, curr_y)*delta_sq;
	    values[0][i] += latest;
	    curr_x -= delta;
	}
    }

				// now do values[1-size][0]
    curr_x = start_x;
    for(int i = 1 ; i < size ; i++) {
	curr_y = start_y;
	curr_x += delta;
	latest = thresh;
	values[i][0] = values[i-1][0];
	while(latest > thresh*thresh) {
	    latest = func_at(curr_x, curr_y)*delta_sq;
	    values[i][0] += latest;
	    curr_y -= delta;
	}
    }
				// now do rest
    curr_x = start_x;
    for(int i = 1 ; i < size ; i++) {
	curr_x += delta;
	curr_y = start_y;
	for(int j = 1 ; j < size ; j++) {
	    curr_y += delta;
	    values[i][j] = func_at(curr_x, curr_y)*delta_sq;
	    values[i][j] += values[i-1][j] + values[i][j-1] - values[i-1][j-1];
	}
    }

    c1 = ((double)size)/span;
    c2 = size/2;
}

double Splat::func_at(double x, double y) {
    return(coef1*exp(-(x*x+y*y)*coef2));
}

//void Splat::set_offsets(double x, double y) {
    
    

//}

#define FFUCKK(d) ((int)((d)+0.5))

double Splat::area_under(double x, double y) {

//    double sp_x = x*span/size;
//    double sp_y = y*span/size;
    int xmin;
    int xmax;
    int ymin;
    int ymax;
#if 1
    xmin = FFUCKK((x-0.5)*c1)+c2;
    xmax = FFUCKK((x+0.5)*c1)+c2;
    ymin = FFUCKK((y-0.5)*c1)+c2;
    ymax = FFUCKK((y+0.5)*c1)+c2;
#else
    xmin = xmax = ymin = ymax = 0;
#endif
#if 1
    if(xmax < 0)
	xmin = xmax = 0;
    else {
	if(xmin >= size)
	    xmin = xmax = size - 1;
	else {
	    if(xmin < 0)
		xmin = 0;
	    if(xmax >= size)
		xmax = size - 1;
	}
    }

    if(ymax < 0)
	ymin = ymax = 0;
    else {
	if(ymin >= size)
	    ymin = ymax = size - 1;
	else {
	    if(ymin < 0)
		ymin = 0;
	    if(ymax >= size)
		ymax = size - 1;
	}
    }
#endif
    return((values[xmax][ymax]+values[xmin][ymin])-
	   (values[xmin][ymax]+values[xmax][ymin]));
}
